<?php
/*
 * @version $Id: HEADER 2011-03-12 18:01:26 tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin manufacturersimports v1.4.0 - GLPI 0.80
// ----------------------------------------------------------------------
 */

function plugin_manufacturersimports_install() {
   global $DB;

	include_once (GLPI_ROOT."/plugins/manufacturersimports/inc/profile.class.php");
   
   $update=false;
	if (!TableExists("glpi_plugin_suppliertag_profiles") && !TableExists("glpi_plugin_manufacturersimports_profiles")) {
      
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/empty-1.3.0.sql");

	} else if (TableExists("glpi_plugin_suppliertag_config") && !FieldExists("glpi_plugin_suppliertag_config","FK_entities")) {
      
      $update=true;
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.1.sql");
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.2.0.sql");
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.3.0.sql");

	} else if (TableExists("glpi_plugin_suppliertag_profiles") && FieldExists("glpi_plugin_suppliertag_profiles","interface")) {
      
      $update=true;
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.2.0.sql");
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.3.0.sql");

	} else if (!TableExists("glpi_plugin_manufacturersimports_profiles")) {
      
      $update=true;
		$DB->runFile(GLPI_ROOT ."/plugins/manufacturersimports/sql/update-1.3.0.sql");

	}
   
   if ($update) {
      
      $query_="SELECT *
            FROM `glpi_plugin_manufacturersimports_profiles` ";
      $result_=$DB->query($query_);
      if ($DB->numrows($result_)>0) {

         while ($data=$DB->fetch_array($result_)) {
            $query="UPDATE `glpi_plugin_manufacturersimports_profiles`
                  SET `profiles_id` = '".$data["id"]."'
                  WHERE `id` = '".$data["id"]."';";
            $result=$DB->query($query);

         }
      }
      
      $query="ALTER TABLE `glpi_plugin_manufacturersimports_profiles`
               DROP `name` ;";
      $result=$DB->query($query);
      
      Plugin::migrateItemType(
         array(2150=>'PluginManufacturersimportsModel',2151=>'PluginManufacturersimportsConfig'),
         array("glpi_bookmarks", "glpi_bookmarks_users", "glpi_displaypreferences",
               "glpi_documents_items", "glpi_infocoms", "glpi_logs", "glpi_tickets"),
         array("glpi_plugin_manufacturersimports_models","glpi_plugin_manufacturersimports_logs"));
	}
	
	PluginManufacturersimportsProfile::createFirstAccess($_SESSION['glpiactiveprofile']['id']);
	return true;
}

function plugin_manufacturersimports_uninstall() {
	global $DB;

	$tables = array("glpi_plugin_manufacturersimports_profiles",
					"glpi_plugin_manufacturersimports_configs",
					"glpi_plugin_manufacturersimports_models",
					"glpi_plugin_manufacturersimports_logs");

	foreach($tables as $table)
		$DB->query("DROP TABLE IF EXISTS `$table`;");
   
   //old versions	
   $tables = array("glpi_plugin_suppliertag_config",
					"glpi_plugin_suppliertag_profiles",
					"glpi_plugin_suppliertag_models",
					"glpi_plugin_suppliertag_imported");

	foreach($tables as $table)
		$DB->query("DROP TABLE IF EXISTS `$table`;");
		
	return true;
}

// Define dropdown relations
function plugin_manufacturersimports_getDatabaseRelations() {

	$plugin = new Plugin();
	if ($plugin->isActivated("manufacturersimports"))
		return array (
			"glpi_entities" => array (
				"glpi_plugin_manufacturersimports_configs" => "entities_id"
			),
			"glpi_manufacturers" => array (
				"glpi_plugin_manufacturersimports_configs" => "manufacturers_id"
			),
			"glpi_suppliers" => array (
				"glpi_plugin_manufacturersimports_configs" => "suppliers_id"
			),
			"glpi_documentcategories" => array (
				"glpi_plugin_manufacturersimports_configs" => "documentcategories_id"
			),
			"glpi_documents" => array (
				"glpi_plugin_manufacturersimports_logs" => "documents_id"
			),
			"glpi_profiles" => array ("glpi_plugin_manufacturersimports_profiles" => "profiles_id")
		);
	else
		return array ();

}

////// SEARCH FUNCTIONS ///////() {

function plugin_manufacturersimports_getAddSearchOptions($itemtype) {
	global $LANG;

    $sopt=array();

    if (in_array($itemtype, PluginManufacturersimportsModel::getClasses())) {
      if (plugin_manufacturersimports_haveRight("manufacturersimports","r")) {
        $sopt[2150]['table']='glpi_plugin_manufacturersimports_models';
        $sopt[2150]['field']='model_name';
        $sopt[2150]['linkfield']='';
        $sopt[2150]['name']=$LANG['plugin_manufacturersimports']['title'][1]." - ".$LANG['plugin_manufacturersimports']['import'][32];
        $sopt[2150]['forcegroupby']='1';
      }
	}
	return $sopt;
}

//for search
function plugin_manufacturersimports_addLeftJoin($type,$ref_table,$new_table,$linkfield,&$already_link_tables) {

	switch ($new_table) {

		case "glpi_plugin_manufacturersimports_models" : // From items
			$out= " LEFT JOIN `glpi_plugin_manufacturersimports_models` ON (`$ref_table`.`id` = `glpi_plugin_manufacturersimports_models`.`items_id` AND `glpi_plugin_manufacturersimports_models`.`itemtype` = '$type') ";
			return $out;
			break;
	}

	return "";
}

//force groupby for multible links to items
function plugin_manufacturersimports_forceGroupBy($type) {

	return true;
	switch ($type) {
		case 'PluginManufacturersimportsModel':
			return true;
			break;

	}
	return false;
}

////// SPECIFIC MODIF MASSIVE FUNCTIONS ///////

function plugin_manufacturersimports_MassiveActions($type) {
	global $LANG;
  
	if (in_array($type, PluginManufacturersimportsModel::getClasses())) {
      return array("plugin_manufacturersimports_add_model"=>$LANG['plugin_manufacturersimports']['import'][12]);
   }
	return array();
}

function plugin_manufacturersimports_MassiveActionsDisplay($options=array()) {
	global $LANG;
	
	if (in_array($options['itemtype'], PluginManufacturersimportsModel::getClasses())) {
      echo "<input type=\"text\" name=\"model_name\">&nbsp;";
      echo "<input type=\"submit\" name=\"massiveaction\" class=\"submit\" value=\"".$LANG['buttons'][2]."\" >";
   }
	return "";
}

function plugin_manufacturersimports_MassiveActionsProcess($data) {
	global $LANG;
  
  $PluginManufacturersimportsModel=new PluginManufacturersimportsModel();
  
	switch ($data['action']) {

		case "plugin_manufacturersimports_add_model":
				foreach ($data["item"] as $key => $val) {
					if ($val==1) {
						// Items exists ?
						$item = new $data["itemtype"]();
						if ($item->getFromDB($key)) {
							$PluginManufacturersimportsModel->addModel($key,$data['itemtype'],$data['model_name']);
						}
					}
				}
         break;
	}
}

// Define headings added by the plugin
function plugin_get_headings_manufacturersimports($item,$withtemplate) {
	global $LANG;
  
	if (get_class($item)=='Profile') {
		if ($item->getField('id') && $item->getField('interface')!='helpdesk') {
			return array(
				1 => $LANG['plugin_manufacturersimports']['title'][1],
				);
		} else {
			return array();
		}
	} else if (in_array(get_class($item), PluginManufacturersimportsModel::getClasses())) {
		// template case
		if ($withtemplate) {
			return array();

		// Non template case
		} else  {
			return array(
				1 => $LANG['plugin_manufacturersimports']['title'][1],
				);
		}
	}
	return false;
}

// Define headings actions added by the plugin
function plugin_headings_actions_manufacturersimports($item) {
  
	if (in_array(get_class($item),PluginManufacturersimportsModel::getClasses()) ||
		(get_class($item)=='Profile' && $item->getField('interface')!='helpdesk')) {
		return array(
         1 => "plugin_headings_manufacturersimports",
      );
	} else
		return false;
}

// Action heading
function plugin_headings_manufacturersimports($item) {
	global $CFG_GLPI;
  
   $PluginManufacturersimportsProfile=new PluginManufacturersimportsProfile();
   $PluginManufacturersimportsModel=new PluginManufacturersimportsModel();
   
   switch (get_class($item)) {
      case 'Profile' :
         if (!$PluginManufacturersimportsProfile->getFromDBByProfile($item->getField('id')))
            $PluginManufacturersimportsProfile->createAccess($item->getField('id'));
         $PluginManufacturersimportsProfile->showForm($item->getField('id'), array('target' => $CFG_GLPI["root_doc"]."/plugins/manufacturersimports/front/profile.form.php"));
         break;
      default :
         if (in_array(get_class($item), PluginManufacturersimportsModel::getClasses())) {
            $PluginManufacturersimportsModel->showForm(get_class($item),$item->getField('id'));
         }
         break;
   }
}

?>