<?php
/*
 * @version $Id: HEADER 2011-03-12 18:01:26 tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin manufacturersimports v1.4.0 - GLPI 0.80
// ----------------------------------------------------------------------
 */

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

class PluginManufacturersimportsConfig extends CommonDBTM {
   
   static function getTypeName() {
      global $LANG;

      return $LANG['plugin_manufacturersimports']['config'][6];
   }
   
   function canCreate() {
      return plugin_manufacturersimports_haveRight('manufacturersimports', 'w');
   }

   function canView() {
      return plugin_manufacturersimports_haveRight('manufacturersimports', 'r');
   }
   
   function showMenu() {
      global $LANG;
      
      echo "<form method='post' action='".$this->getFormURL()."'>";
      echo "<table class='tab_cadre_fixe' cellpadding='5'><tr><th colspan='2'>";
      echo $LANG['plugin_manufacturersimports']['config'][6]." : </th></tr>";
      echo "<tr class='tab_bg_1 center'><td>";
      echo "<select name='supplier'>";
      echo "<option value='0'>".DROPDOWN_EMPTY_VALUE."</option>";
      echo "<option value='Dell'>Dell</option>";
      echo "<option value='HP'>HP</option>";
      echo "<option value='Fujitsu-Siemens'>Fujitsu-Siemens</option>";
      //echo "<option value='IBM'>IBM</option>";
      echo "<option value='Toshiba'>Toshiba</option>";
      echo "</select";
      echo "</td><td>";
      echo "<div align='center'><input type='submit' name='config_supplier' value=\"".$LANG['buttons'][2]."\" class='submit' ></div></td></tr>";
      echo "</table>";
      echo "</form>";
   }
   
   function checkIfConfExists($supplier) {
      global $DB;

      $query = "SELECT `".$this->getTable()."`.*
          FROM `".$this->getTable()."` ";
      $query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`id` = `".$this->getTable()."`.`entities_id`)"
        ." WHERE `".$this->getTable()."`.`id` != 4 AND `".$this->getTable()."`.`name` = '".$supplier."' ";
      $query.= "".getEntitiesRestrictRequest(" AND",$this->getTable(),'','',true);
      $query.= " ORDER BY `".$this->getTable()."`.`entities_id` DESC";

      $result=$DB->query($query);
      if ($DB->numrows($result) > 0) {
         while ($data=$DB->fetch_array($result)) {
            $supplierID=$data["id"];
         }

         return $supplierID;
      } else
         return false;
   }
  
	/**
	 * Preconfig datas for standard system
	 * @param $type type of standard system : AD
	 *@return nothing
	 **/
	function preconfig($type) {

		switch($type) {
			case 'Dell':
			$this->fields["name"]="Dell";
			$this->fields["supplier_url"]="http://support.dell.com/support/topics/global.aspx/support/my_systems_info/details?c=us&l=en&s=bsd&ServiceTag=";
			break;
			case 'HP':
			$this->fields["name"]="HP";
			$this->fields["supplier_url"]="http://h20000.www2.hp.com/bizsupport/TechSupport/WarrantyResults.jsp?";
			break;
			case 'Fujitsu-Siemens':
			$this->fields["name"]="Fujitsu-Siemens";
			$this->fields["supplier_url"]="http://sali.uk.ts.fujitsu.com/ServiceEntitlement/service.asp?command=search&";
			break;
			case 'IBM':
			$this->fields["name"]="IBM";
			$this->fields["supplier_url"]="http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/warranty?";
			break;
			case 'Toshiba':
			$this->fields["name"]="Toshiba";
			$this->fields["supplier_url"]="http://aps2.toshiba-tro.de/unit-details-php/unitdetails.aspx?";
			break;
			default:
			$this->post_getEmpty();
			break;

		}
	}

	function post_addItem() {
		global $DB;

		if ($this->fields["is_recursive"]) {
			$query="DELETE FROM `".$this->getTable()."`
					WHERE `name` = '".$this->fields["name"]."'
					AND `id` != '".$this->fields['id']."' " .
					getEntitiesRestrictRequest('AND',$this->getTable(),'',getSonsOf("glpi_entities",$this->fields["entities_id"]));

			$result=$DB->query($query);
		}
	}

	function post_updateItem($history=1) {
		global $DB;

		if ($this->fields["is_recursive"]) {
			$query="DELETE FROM `".$this->getTable()."`
					WHERE `name` = '".$this->fields["name"]."'
					AND `id` != '".$this->fields["id"]."' " .
					getEntitiesRestrictRequest('AND',$this->getTable(),'',getSonsOf("glpi_entities",$this->fields["entities_id"]));

			$result=$DB->query($query);
		}
	}
	
	function showForm ($ID,$supplier) {
      global $CFG_GLPI, $LANG;

      if ($ID>0) {
         $this->check($ID,'r');
      } else {
         $this->check(-1,'w');
         $this->getEmpty();
          if (isset($supplier)) {
            $this->preconfig($supplier);
         }
      }
      
      $input=array("name"=>$this->fields["name"],"supplier_url"=>$this->fields["supplier_url"]);
      $canedit=$this->can($ID,'w',$input);
      $canrecu=$this->can($ID,'recursive',$input);
      
      $target = $CFG_GLPI["root_doc"]."/plugins/manufacturersimports/front/manufacturer.form.php";
      echo "<form name='form' method='post' action='".$target."'>";
      echo "<div align=\"center\"><table class=\"tab_cadre\"  cellspacing=\"2\" cellpadding=\"2\">";
      echo "<tr><th colspan='2'>".$LANG['plugin_manufacturersimports']['config'][6]."</th></tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2'></td><td class='tab_bg_2' colspan='2'><a  href='".$target."?preconfig=$supplier'>".$LANG['ldap'][16]."</a></td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['common'][16]."</td>";
      echo "<td class='tab_bg_2 left'>";
      echo $this->fields["name"];
      echo "<input type='hidden' name='name' value=\"".$this->fields["name"]."\">\n";
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][0]."</td>";
      echo "<td class='tab_bg_2 left'>";
      echo "<input type='text' name='supplier_url' size='150' value='".$this->fields["supplier_url"]."'>";
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][1]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::show('Manufacturer', array('name' => "manufacturers_id",'value' => $this->fields["manufacturers_id"]));
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][2]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::show('Supplier', array('name' => "suppliers_id",'value' => $this->fields["suppliers_id"]));
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][3]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::showInteger("warranty_duration",$this->fields["warranty_duration"],0,120);
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][4]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::showYesNo("document_adding",$this->fields["document_adding"]);
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][5]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::show('DocumentCategory', array('name' => "documentcategories_id",'value' => $this->fields["documentcategories_id"]));
      echo "</td>";
      echo "</tr>";

      echo "<tr>";
      echo "<td class='tab_bg_2 center'>".$LANG['plugin_manufacturersimports']['config'][7]."</td>";
      echo "<td class='tab_bg_2 left'>";
      Dropdown::showYesNo("comment_adding",$this->fields["comment_adding"]);
      echo "</td>";
      echo "</tr>";
      if (isMultiEntitiesMode()) {
         echo "<tr>";
         echo "<td class='tab_bg_2 center'>".$LANG['entity'][0]."</td>";
         echo "<td class='tab_bg_2 left'>";
         Dropdown::show('Entity', array('name' => "entities_id",'value' => $this->fields["entities_id"]));
         echo "</td>";
         echo "</tr>";
      } else {
         echo "<input type='hidden' name='entities_id' value='".$_SESSION["glpiactive_entity"]."'>";
      }

      echo "<tr>";
      echo "<td class='tab_bg_2'></td>";
      echo "<td class='tab_bg_2'>";
      if (isset($this->fields["is_recursive"]) && isMultiEntitiesMode()) {
         echo $LANG['entity'][9].":&nbsp;";

         if (!$this->can($ID,'recursive')) {
            echo Dropdown::getYesNo($this->fields["is_recursive"]);
            $comment=$LANG['common'][86];
            $image="/pics/lock.png";
         } else if (!$this->canUnrecurs()) {
            echo Dropdown::getYesNo($this->fields["is_recursive"]);
            $comment=$LANG['common'][84];
            $image="/pics/lock.png";
         } else {
            Dropdown::showYesNo("is_recursive",$this->fields["is_recursive"]);
            $comment=$LANG['common'][85];
            $image="/pics/aide.png";
         }
         $rand=mt_rand();
         echo "&nbsp;<img alt='' src='".$CFG_GLPI["root_doc"].$image."' onmouseout=\"cleanhide('comments_recursive$rand')\" onmouseover=\"cleandisplay('comments_recursive$rand')\">";
         echo "<span class='over_link' id='comments_recursive$rand'>$comment</span>";

      } else {
         echo "&nbsp;";
      }
      echo "</td>";
      echo "</tr>";

      if ($canedit) {

         if (empty($ID)||$ID<0) {

            echo "<tr>";
            echo "<td class='tab_bg_2 top' colspan='3'>";
            echo "<div align='center'><input type='submit' name='add' value=\"".$LANG['buttons'][8]."\" class='submit'></div>";
            echo "</td>";
            echo "</tr>";

         } else {

         echo "<tr>";
         echo "<td class='tab_bg_2 top' colspan='3'><div align='center'>";
         echo "<input type='hidden' name='id' value=\"$ID\">\n";
         echo "<input type='submit' name='update_config' value=\"".$LANG['buttons'][7]."\" class='submit' >";
         echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' name='delete' value=\"".$LANG['buttons'][6]."\" class='submit'></div>";
         echo "</td>";
         echo "</tr>";

         }
      }

      echo "</table></div>";
      echo "</form><br>";
   }
}

?>