<?php
/*
 * @version $Id: HEADER 2011-03-12 18:01:26 tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin manufacturersimports v1.4.0 - GLPI 0.80
// ----------------------------------------------------------------------
 */

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

class PluginManufacturersimportsPreImport extends CommonDBTM {
   
   function canCreate() {
      return plugin_manufacturersimports_haveRight("manufacturersimports","w");
   }

   function canView() {
      return plugin_manufacturersimports_haveRight("manufacturersimports","r");
   }
   
   function showAllItems($myname,$value_type=0,$value=0,$entity_restrict=-1,$types='') {
      global $LANG,$CFG_GLPI;
      
      if (!is_array($types)) {
      
         $PluginManufacturersimportsModel=new PluginManufacturersimportsModel();
         $types=$PluginManufacturersimportsModel->getClasses();
      }

      $rand=mt_rand();

      $options=array();

      foreach ($types as $type) {
         $item = new $type();
         $options[$type]=$item->getTypeName();
      }
      asort($options);
      if (count($options)) {
         echo "<select name='$myname' id='item_type$rand'>\n";
         echo "<option value='0'>".DROPDOWN_EMPTY_VALUE."</option>\n";
         foreach ($options as $key => $val) {
            echo "<option value='".$key."' ".($key==$value?"selected": "").">".$val."</option>\n";
         }
         echo "</select>&nbsp;";
      }
   }
   
   /**
   * Prints search form
   *
   * @param $manufacturer the supplier choice
   * @param $type the device type
   * @return nothing (print out a table)
   *
   */
   function searchForm ($type,$manufacturer,$imported) {
      global $DB,$LANG,$CFG_GLPI;

      echo "<form name='form' method='post' action='".$CFG_GLPI["root_doc"]."/plugins/manufacturersimports/front/import.php'>";
      echo "<div align='center'><table class='tab_cadre' cellpadding='5'>";
      echo "<tr><th colspan='4'>".$LANG['plugin_manufacturersimports']['import'][0]."</th></tr>";

      echo "<tr class='tab_bg_2'>";
      echo "<td class='center'>";
      $PluginManufacturersimportsModel=new PluginManufacturersimportsModel();
      $this->showAllItems("itemtype",0,$type,-1,$PluginManufacturersimportsModel->getClasses());

      echo "</td><td>";

      //manufacturer choice
      $query = "SELECT `glpi_plugin_manufacturersimports_configs`.*
          FROM `glpi_plugin_manufacturersimports_configs` ";
      $query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`id` = `glpi_plugin_manufacturersimports_configs`.`entities_id`)"
        ." WHERE `glpi_plugin_manufacturersimports_configs`.`manufacturers_id` != '0'
        AND `glpi_plugin_manufacturersimports_configs`.`id` != 4 ";
      $query.= "".getEntitiesRestrictRequest(" AND","glpi_plugin_manufacturersimports_configs",'','',true);
      $query.= " ORDER BY `glpi_plugin_manufacturersimports_configs`.`entities_id`, `glpi_plugin_manufacturersimports_configs`.`name`";
      $result=$DB->query($query);
      $number = $DB->numrows($result);

      if ($number !="0") {
         echo "<select name=\"manufacturers_id\">";
         echo "<option value=\"0\">".DROPDOWN_EMPTY_VALUE."</option>";

         while ($data=$DB->fetch_array($result)) {
            if ($data["id"]!=4) {
               echo "<option value='".$data["id"]."' ".($manufacturer=="".$data["id"].""?" selected ":"").">";
               if (isMultiEntitiesMode())
                  echo Dropdown::getDropdownName("glpi_entities",$data["entities_id"])." > ";
               echo $data["name"];
               if (empty($data["name"]) || $_SESSION["glpiis_ids_visible"]) {
                  echo " (";
                  echo $data["id"].")";
               }
               echo "</option>";
            }
         }
         echo "</select>";
         echo "</td><td>";
         echo "<select name=\"imported\">";
         echo "<option value='1' ".($imported=="1"?" selected ":"").">".$LANG['plugin_manufacturersimports']['config'][8]."</option>";
         echo "<option value='2' ".($imported=="2"?" selected ":"").">".$LANG['plugin_manufacturersimports']['config'][9]."</option>";
         echo "</select>";

      } else {
         //please configure a supplier
         echo "<a href='".$CFG_GLPI["root_doc"]."/plugins/manufacturersimports/front/config.form.php'>".$LANG['plugin_manufacturersimports']['import'][31]."</a>";
      }

      echo "</td><td>";
      echo "<input type=\"submit\" name=\"typechoice\" class=\"submit\" value=\"".$LANG['buttons'][2]."\" >";

      echo "</td>";
      echo "</tr>";

      echo "</table></div></form>";
   }

   /**
   * Prints display Search Header
   *
   * @param $fixed if fixed cells
   * @param $output_type the output_type
   * @return nothing (print out a table)
   *
   */
   function displaySearchHeader($output_type,$fixed=0) {
    
      $out="";
      switch ($output_type) {
         default :
            if ($fixed) {
               $out="<div class='center'><table border='0' class='tab_cadre_fixehov'>\n";
            } else {
               $out="<div class='center'><table border='0' class='tab_cadrehov'>\n";
            }
            break;
      }
      return $out;
   }
  
   /**
   * Fonction to use the supplier url
   *
   * @param $suppliername the suppliername
   * @param $supplierUrl the supplierUrl (in plugin config)
   * @param $compSerial the serial of the device
   * @param $otherSerial the otherSerial (model) of the device
   * @return $url of the supplier
   *
   */
   function selectSupplier ($suppliername,$supplierUrl,$compSerial,$otherSerial) {

      if ($suppliername=="Dell") {

         $url = $supplierUrl.$compSerial;

      } else if ($suppliername=="HP") {//hp

         //list($otherSerial,$Serial)=explode("-",$compSerial);
         //$url = $supplierUrl."lang=en&cc=us&prodSeriesId=454811&prodTypeId=12454&sn=".$compSerial."&pn=".$otherSerial."&country=US&nickname=&find=Display+Warranty+Information+%C2%BB";
         $url = $supplierUrl."nickname=&sn=".$compSerial."&country=FR&lang=en&cc=us&pn=".$otherSerial."&find=Display+Warranty+Information+%BB&";
 
      } else if ($suppliername=="Fujitsu-Siemens") {//http://sali.uk.ts.fujitsu.com/ServiceEntitlement/service.asp?command=search&

         $url = $supplierUrl."snr=".$compSerial;

      } else if ($suppliername=="IBM") {//http://www-304.ibm.com/jct01004c/systems/support/supportsite.wss/warranty?type=[MODELE]&serial=[SERIAL]&brandind=5000008&Submit=Submit&action=warranty

         //list($otherSerial,$Serial)=explode("-",$compSerial);
         $url = $supplierUrl."type=".$otherSerial."&serial=".$compSerial."&brandind=5000008&Submit=Submit&action=warranty";

      } else if ($suppliername=="Toshiba") {//http://aps2.toshiba-tro.de/unit-details-php/unitdetails.aspx?SerialNumber=[SERIAL]&ModelPartNumber=[MODELE]&openbox=warranty1

         //list($otherSerial,$Serial)=explode("/",$compSerial);
         $url = $supplierUrl."SerialNumber=".$compSerial."&ModelPartNumber=".$otherSerial."&openbox=warranty1";

      }

      return $url;
   }
  
   function selectAlreadyImported($row_num,$item_num,$line,$output_type,$configID) {
      global $LANG,$DB,$CFG_GLPI;
      
      $infocom= new Infocom();
      $canedit=$this->canCreate() && $infocom->canUpdate();

      $PluginManufacturersimportsConfig= new PluginManufacturersimportsConfig();
      $PluginManufacturersimportsConfig->GetFromDB($configID);
      $suppliername=$PluginManufacturersimportsConfig->fields["name"];
      $supplierUrl=$PluginManufacturersimportsConfig->fields["supplier_url"];
      $supplierId=$PluginManufacturersimportsConfig->fields["suppliers_id"];
      $supplierWarranty=$PluginManufacturersimportsConfig->fields["warranty_duration"];

      $row_num++;

      $PluginManufacturersimportsModel= new PluginManufacturersimportsModel();
      $otherSerial=$PluginManufacturersimportsModel->checkIfModelNeeds($line["itemtype"],$line["id"]);

      echo Search::showNewLine($output_type,$row_num%2);
      $ic = new Infocom;
      $output_check="";
      if ($canedit && $output_type==HTML_OUTPUT) {
         $sel="";
         if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
         $output_check="<input type='checkbox' name='item[".$line["id"]."]' value='1' $sel>";
         if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
            if (!$otherSerial)
               $output_check="";
      }

      echo Search::showItem($output_type,$output_check,$item_num,$row_num);
      $link=getItemTypeFormURL($line["itemtype"]);
      $output_link="<a href='".$link."?id=".$line["id"]."'>".$line["name"]."</a><br>".$line["model_name"];

      echo Search::showItem($output_type,$output_link,$item_num,$row_num);
      if (isMultiEntitiesMode())
         echo Search::showItem($output_type,Dropdown::getDropdownName("glpi_entities",$line['entities_id']),$item_num,$row_num);

      if ($suppliername) {
         //On complete l url du support du fournisseur avec le modele si besoin
         $url=$this->selectSupplier($suppliername,$supplierUrl,$line['serial'],$otherSerial);

         //serial
         echo Search::showItem($output_type,$line['serial'],$item_num,$row_num);

         //otherserial
         if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
            $field=$otherSerial;
            if (!$otherSerial)
               $field="<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][12]."</span>";
            echo Search::showItem($output_type,$field,$item_num,$row_num);
         }

         //display infocoms
         $output_ic="";
         if ($ic->getfromDBforDevice($line["itemtype"],$line["id"])) {
            $output_ic.=$LANG['financial'][26].":".Dropdown::getDropdownName("glpi_suppliers",$ic->fields["suppliers_id"])."<br>";
            $output_ic.=$LANG['financial'][14]." : ".convdate($ic->fields["buy_date"])."<br>";
            $output_ic.=$LANG['financial'][29].":".convdate($ic->fields["warranty_date"])."<br>";
            if ($ic->fields["warranty_duration"]==-1)
               $output_ic.=$LANG['financial'][15].":".$LANG['financial'][2]."<br>";
            else
               $output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
            $output_ic.=$LANG['financial'][88];
            $output_ic.=getWarrantyExpir($ic->fields["warranty_date"],$ic->fields["warranty_duration"]);
         }
         echo Search::showItem($output_type,$output_ic,$item_num,$row_num);

         //display enterprise and warranty selection
         echo "<td>".Dropdown::getDropdownName("glpi_suppliers",$ic->fields["suppliers_id"])."</td>";
         if ($ic->fields["warranty_duration"]==-1) {
            echo "<td>".$LANG['financial'][2]."</td>";
         } else {
            echo "<td>".$ic->fields["warranty_duration"]."</td>";
         }

         //url to supplier
         $output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_manufacturersimports']['import'][6]."</a>";
         echo Search::showItem($output_type,$output_url,$item_num,$row_num);

         //status
         $output_doc="<span class='plugin_manufacturersimports_import_OK'>".$LANG['plugin_manufacturersimports']['import'][17];
         if (!empty($line["date_import"]))
            $output_doc.=" (".convdate($line["date_import"]).")";
         $output_doc.="</span>";

         echo Search::showItem($output_type,$output_doc,$item_num,$row_num);

         //display associated doc
         $doc = new document();
         if ($doc->GetFromDB($line["documents_id"]))
            echo Search::showItem($output_type,$doc->getDownloadLink(),$item_num,$row_num);
         else
            echo Search::showItem($output_type,"",$item_num,$row_num);

         echo Search::showEndLine($output_type);
      }
   }

   function selectInFault($row_num,$item_num,$line,$output_type,$configID) {
      global $LANG,$DB,$CFG_GLPI;
      
      $infocom= new Infocom();
      $canedit=$this->canCreate() && $infocom->canUpdate();

      $PluginManufacturersimportsConfig= new PluginManufacturersimportsConfig();
      $PluginManufacturersimportsConfig->GetFromDB($configID);
      $suppliername=$PluginManufacturersimportsConfig->fields["name"];
      $supplierUrl=$PluginManufacturersimportsConfig->fields["supplier_url"];
      $supplierId=$PluginManufacturersimportsConfig->fields["suppliers_id"];
      $supplierWarranty=$PluginManufacturersimportsConfig->fields["warranty_duration"];

      $row_num++;

      //On complete l url du support du fournisseur avec le modele si besoin
      $PluginManufacturersimportsModel= new PluginManufacturersimportsModel();
      $otherSerial=$PluginManufacturersimportsModel->checkIfModelNeeds($line["itemtype"],$line["id"]);
      
      if ($suppliername) {

         echo Search::showNewLine($output_type,$row_num%2);
         $ic = new Infocom;
         $output_check="";
         if ($canedit && $output_type==HTML_OUTPUT) {
            $sel="";
            if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
            $output_check="<input type='checkbox' name='item[".$line["id"]."]' value='1' $sel>";
            if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
               if (!$otherSerial)
                  $output_check="";
         }

         echo Search::showItem($output_type,$output_check,$item_num,$row_num);
         $link=getItemTypeFormURL($line["itemtype"]);
         $output_link="<a href='".$link."?id=".$line["id"]."'>".$line["name"]."</a><br>".$line["model_name"];
         echo Search::showItem($output_type,$output_link,$item_num,$row_num);
         if (isMultiEntitiesMode())
            echo Search::showItem($output_type,Dropdown::getDropdownName("glpi_entities",$line['entities_id']),$item_num,$row_num);

         $url=$this->selectSupplier($suppliername,$supplierUrl,$line["serial"],$otherSerial);

         echo Search::showItem($output_type,$line["serial"],$item_num,$row_num);

         if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
            $field=$otherSerial;
            if (!$otherSerial)
               $field="<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][12]."</span>";
            echo Search::showItem($output_type,$field,$item_num,$row_num);
         }
         //display infocoms
         $output_ic="";
         if ($ic->getfromDBforDevice($line["itemtype"],$line["id"])) {
            $output_ic.=$LANG['financial'][26].":".Dropdown::getDropdownName("glpi_suppliers",$ic->fields["suppliers_id"])."<br>";
            $output_ic.=$LANG['financial'][14]." : ".convdate($ic->fields["buy_date"])."<br>";
            $output_ic.=$LANG['financial'][29].":".convdate($ic->fields["warranty_date"])."<br>";
            $output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
            $output_ic.=$LANG['financial'][88];
            $output_ic.=getWarrantyExpir($ic->fields["warranty_date"],$ic->fields["warranty_duration"]);
         }
         echo Search::showItem($output_type,$output_ic,$item_num,$row_num);

         //display enterprise and warranty selection
         echo "<td>";
         if (isMultiEntitiesMode() && $supplierId) {
            $supplier=new Supplier();
            $supplier->getFromDB($supplierId);
            if ($supplier->fields["is_recursive"] || $supplier->fields["entities_id"]==$line['entities_id'])
               Dropdown::show('Supplier', array('name' => "to_suppliers_id".$line["id"],'value' => $supplierId,'comments' => 0,'entity' => $line['entities_id']));
            else {
               echo "<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][7]."</span>";
               echo "<input type='hidden' name='to_suppliers_id".$line["id"]."' value='-1'>";
            }
         } else
            Dropdown::show('Supplier', array('name' => "to_suppliers_id".$line["id"],'value' => $supplierId,'comments' => 0,'entity' => $line['entities_id']));
            
         echo "</td>";
         echo "<td>";
         Dropdown::showInteger("to_warranty_duration".$line["id"],$supplierWarranty,0,120,1,array(-1=>$LANG['financial'][2]));
         echo "</td>";

         //supplier url
         $output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_manufacturersimports']['import'][6]."</a>";
         echo Search::showItem($output_type,$output_url,$item_num,$row_num);

         //status
         $output_doc="<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][18];
         if (!empty($data["date_import"]))
            $output_doc.=" (".convdate($data["date_import"]).")";
         $output_doc.="</span>";
         echo Search::showItem($output_type,$output_doc,$item_num,$row_num);

         //no associated doc
         echo Search::showItem($output_type,"",$item_num,$row_num);

         echo Search::showEndLine($output_type);

      }
   }


   function selectNotImported($row_num,$item_num,$line,$output_type,$configID) {
      global $LANG,$DB,$CFG_GLPI;
      
      $infocom= new Infocom();
      $canedit=$this->canCreate() && $infocom->canUpdate();

      $PluginManufacturersimportsConfig= new PluginManufacturersimportsConfig();
      $PluginManufacturersimportsConfig->GetFromDB($configID);
      $suppliername=$PluginManufacturersimportsConfig->fields["name"];
      $supplierUrl=$PluginManufacturersimportsConfig->fields["supplier_url"];
      $supplierId=$PluginManufacturersimportsConfig->fields["suppliers_id"];
      $supplierWarranty=$PluginManufacturersimportsConfig->fields["warranty_duration"];

      $row_num++;

      //On complete l url du support du fournisseur avec le modele si besoin
      $PluginManufacturersimportsModel= new PluginManufacturersimportsModel();
      $otherSerial=$PluginManufacturersimportsModel->checkIfModelNeeds($line["itemtype"],$line["id"]);

      if ($suppliername) {

         echo Search::showNewLine($output_type,$row_num%2);
         $ic = new Infocom;
         $output_check="";
         if ($canedit && $output_type==HTML_OUTPUT) {

            $sel="";
            if (isset($_GET["select"])&&$_GET["select"]=="all") $sel="checked";
            $output_check="<input type='checkbox' name='item[".$line["id"]."]' value='1' $sel>";

            if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba")
               if (!$otherSerial)
               $output_check="";
         }

         echo Search::showItem($output_type,$output_check,$item_num,$row_num);
         $link=getItemTypeFormURL($line["itemtype"]);
         $output_link="<a href='".$link."?id=".$line["id"]."'>".$line["name"]."</a><br>".$line["model_name"];
         echo Search::showItem($output_type,$output_link,$item_num,$row_num);
         if (isMultiEntitiesMode()) {
            echo Search::showItem($output_type,Dropdown::getDropdownName("glpi_entities",$line['entities_id']),$item_num,$row_num);
         }

         $url=$this->selectSupplier($suppliername,$supplierUrl,$line["serial"],$otherSerial);

         echo Search::showItem($output_type,$line["serial"],$item_num,$row_num);

         if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
            $field=$otherSerial;
            if (!$otherSerial)
               $field="<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][12]."</span>";
            echo Search::showItem($output_type,$field,$item_num,$row_num);
         }

         //display infocoms
         $output_ic="";
         if ($ic->getfromDBforDevice($line["itemtype"],$line["id"])) {
            $output_ic.=$LANG['financial'][26].":".Dropdown::getDropdownName("glpi_suppliers",$ic->fields["suppliers_id"])."<br>";
            $output_ic.=$LANG['financial'][14]." : ".convdate($ic->fields["buy_date"])."<br>";
            $output_ic.=$LANG['financial'][29].":".convdate($ic->fields["warranty_date"])."<br>";
            $output_ic.=$LANG['financial'][15].":".$ic->fields["warranty_duration"]." ".$LANG['financial'][57]."<br>";
            $output_ic.=$LANG['financial'][88];
            $output_ic.=getWarrantyExpir($ic->fields["warranty_date"],$ic->fields["warranty_duration"]);
         } else {
            $output_ic.="";
         }
         echo Search::showItem($output_type,$output_ic,$item_num,$row_num);

         //display enterprise and warranty selection
         echo "<td>";
         if (isMultiEntitiesMode() && $supplierId) {
            $supplier=new Supplier();
            $supplier->getFromDB($supplierId);
            if ($supplier->fields["is_recursive"] || $supplier->fields["entities_id"]==$line['entities_id'])
               Dropdown::show('Supplier', array('name' => "to_suppliers_id".$line["id"],'value' => $supplierId,'comments' => 0,'entity' => $line['entities_id']));
            else {
               echo "<span class='plugin_manufacturersimports_import_KO'>".$LANG['plugin_manufacturersimports']['import'][7]."</span>";
               echo "<input type='hidden' name='to_suppliers_id".$line["id"]."' value='-1'>";
            }
         } else
            Dropdown::show('Supplier', array('name' => "to_suppliers_id".$line["id"],'value' => $supplierId,'comments' => 0,'entity' => $line['entities_id']));
         echo "</td>";
         echo "<td>";
         Dropdown::showInteger("to_warranty_duration".$line["id"],$supplierWarranty,0,120,1,array(-1=>$LANG['financial'][2]));
         echo "</td>";

         //supplier url
         $output_url="<a href='".$url."' target='_blank'>".$LANG['plugin_manufacturersimports']['import'][6]."</a>";
         echo Search::showItem($output_type,$output_url,$item_num,$row_num);

         //status
         echo Search::showItem($output_type,$LANG['plugin_manufacturersimports']['import'][19],$item_num,$row_num);

         //no associated doc
         echo Search::showItem($output_type,"",$item_num,$row_num);

         echo Search::showEndLine($output_type);

      }
   }
   /**
   * Prints display pre import
   *
   * @param $type the type of device
   * @param $configID the ID of the supplier config
   * @param $start for pager display
   * @param $complete to see all device (already imported and not)
   * @return nothing (print out a table)
   *
   */
   function seePreImport ($type,$configID,$start,$imported) {
      global $LANG,$DB,$CFG_GLPI;

      $modeltable = "";
      $target = $CFG_GLPI["root_doc"]."/plugins/manufacturersimports/front/import.php";
      
      if ($type && $configID) {

         $PluginManufacturersimportsConfig= new PluginManufacturersimportsConfig();
         $PluginManufacturersimportsConfig->GetFromDB($configID);
         $suppliername=$PluginManufacturersimportsConfig->fields["name"];
         $infocom= new Infocom();
         $canedit=$this->canCreate() && $infocom->canUpdate();

         if (!$start) {
            $start = 0;
         }
         
         $modeltable = getTableForItemType($type."Model");
         $modelfield = getForeignKeyFieldForTable(getTableForItemType($type."Model"));

         $item = new $type();
         $itemtable=getTableForItemType($type);
         
         $query = "SELECT `".$itemtable."`.`id`,`".$itemtable."`.`name`, `".$itemtable."`.`serial`,`".$itemtable."`.`entities_id`, `glpi_plugin_manufacturersimports_logs`.`import_status`, `glpi_plugin_manufacturersimports_logs`.`items_id`, `glpi_plugin_manufacturersimports_logs`.`itemtype`, `glpi_plugin_manufacturersimports_logs`.`documents_id`, `glpi_plugin_manufacturersimports_logs`.`date_import`, '$type' AS type,`$modeltable`.`name` AS model_name
        FROM `".$itemtable."` ";

         //model device left join
         $query.= "LEFT JOIN `$modeltable` ON (`$modeltable`.`id` = `".$itemtable."`.`".$modelfield."`) ";
         $query.=" LEFT JOIN `glpi_entities` ON (`glpi_entities`.`id` = `".$itemtable."`.`entities_id`)";
         $query.=" LEFT JOIN `glpi_plugin_manufacturersimports_configs` ON (`glpi_plugin_manufacturersimports_configs`.`manufacturers_id` = `".$itemtable."`.`manufacturers_id`)";
         $query.=" LEFT JOIN `glpi_plugin_manufacturersimports_logs` ON (`glpi_plugin_manufacturersimports_logs`.`items_id` = `".$itemtable."`.`id` AND `glpi_plugin_manufacturersimports_logs`.`itemtype` = '".$type."')";
         $query.=" LEFT JOIN `glpi_plugin_manufacturersimports_models` ON (`glpi_plugin_manufacturersimports_models`.`items_id` = `".$itemtable."`.`id` AND `glpi_plugin_manufacturersimports_models`.`itemtype` = '".$type."')";
         
         //serial must be not empty
         $query.= " WHERE `".$itemtable."`.`is_deleted` = '0'
          AND `".$itemtable."`.`is_template` = '0'
          AND `glpi_plugin_manufacturersimports_configs`.`id` = '".$configID."'
          AND `".$itemtable."`.`serial` != '' ";
         //already imported
         if ($imported==2) {
         $query.= " AND `import_status` != 2";
            if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
               $query.= " AND `model_name` is NOT NULL ";
            }
            //not imported
         } else if ($imported==1) {
            $query.= " AND (`date_import` IS NULL OR `import_status` = 2 ";
            if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
               $query.= " OR `model_name` IS NULL ";
            }
            $query.= ") ";
         }
         $entities="";
         if ($PluginManufacturersimportsConfig->isRecursive()) {
            $entities = getSonsOf('glpi_entities',$PluginManufacturersimportsConfig->getEntityID());
         } else {
            $entities = $PluginManufacturersimportsConfig->getEntityID();
         }
         $query.= "".getEntitiesRestrictRequest(" AND",$itemtable,'',$entities,$item->maybeRecursive());
         $query.= " ORDER BY `entities_id`,`".$itemtable."`.`name`";

         $result = $DB->query($query);
         $numrows =  $DB->numrows($result);

         if ($start<$numrows) {

            // Set display type for export if define
            $output_type=HTML_OUTPUT;
            if (isset($_GET["display_type"])) {
               $output_type=$_GET["display_type"];
            }
            $parameters="itemtype=$type&amp;manufacturers_id=$configID&amp;imported=$imported";
            $total=0;
            
            if ($output_type==HTML_OUTPUT) {
               $this->printPager($start,$numrows,$target,$parameters,$type);
            }
            // Define begin and end var for loop
            // Search case
            $begin_display=$start;
            $end_display=$start+$_SESSION["glpilist_limit"];

            // Export All case
            if (isset($_GET['export_all'])) {
               $begin_display=0;
               $end_display=$numrows;
            }

            if (isMultiEntitiesMode()) {
               $colsup=1;
            } else {
               $colsup=0;
            }
            //////////////////////HEADER///////////////
            if ($output_type==HTML_OUTPUT) {
               echo "<form method='post' name='massiveaction_form' id='massiveaction_form' action=\"../ajax/massiveaction.php\">";
            }
            echo $this->displaySearchHeader($output_type,0); //table + div
            echo "<tr><th colspan='".($canedit?(11+$colsup):(10+$colsup))."'>".$LANG['plugin_manufacturersimports']['import'][1]." ".$suppliername."</th></tr>";

            echo Search::showNewLine($output_type);
            $header_num=1;

            echo Search::showHeaderItem($output_type,"",$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][2],$header_num);
            if (isMultiEntitiesMode()) {
               echo Search::showHeaderItem($output_type,$LANG['entity'][0],$header_num);
            }
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][3],$header_num);
            if ($suppliername=="HP" || $suppliername=="IBM" || $suppliername=="Toshiba") {
               echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][30],$header_num);
            }
            echo Search::showHeaderItem($output_type,$LANG['financial'][3],$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][26],$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][27],$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][4],$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][16],$header_num);
            echo Search::showHeaderItem($output_type,$LANG['plugin_manufacturersimports']['import'][21],$header_num);

            // End Line for column headers
            echo Search::showEndLine($output_type);

            $i=$start;
            if (isset($_GET['export_all']))
            $i=0;

            if ($i>0) {
               $DB->data_seek($result,$i);
            }

            $row_num=1;

            while ($i < $numrows && $i < $end_display) {
               $i++;

               $item_num=1;
               $line=$DB->fetch_array($result);
               $compSerial = $line['serial'];
               $compId = $line['id'];
               $model=$line["model_name"];
               if (!$line["itemtype"])
                  $line["itemtype"]=$type;
               //1.show already imported items && import_status not failed
               if ($imported==2 && $line["import_status"]==1) {

                  $this->selectAlreadyImported($row_num,$item_num,$line,$output_type,$configID);

               //2.show not imported items (with problem in import)
               } else if ($imported==1 && $line["import_status"]==2) {

                  $this->selectInFault($row_num,$item_num,$line,$output_type,$configID);
                  $total+=1;
               //3.show not imported items
               } else if ($imported==1) {

                  $this->selectNotImported($row_num,$item_num,$line,$output_type,$configID);
                  $total+=1;
               }

            }
            echo "<tr class='tab_bg_1'><td colspan='".($canedit?(11+$colsup):(10+$colsup))."'>";
            echo $LANG['plugin_manufacturersimports']['import'][8]." : ".$total;
            echo "</td></tr>";

            // Close Table
            $title="";
            // Create title
            if ($output_type==PDF_OUTPUT_PORTRAIT|| $output_type==PDF_OUTPUT_LANDSCAPE) {
               $title.=$LANG['plugin_manufacturersimports']['import'][1]." ".$suppliername;
            }

            echo Search::showFooter($output_type,$title);

            //massive action
            if ($canedit && $output_type==HTML_OUTPUT) {
               openArrowMassive("massiveaction_form");
               $this->dropdownMassiveAction($compId,$type,$configID,$start,$imported);
               closeArrowMassive();
               echo "</form>";
            }else{
               echo "</table>";
               echo "</div>";
            }

            echo "<br>";
            if ($output_type==HTML_OUTPUT) {
               $this->printPager($start,$numrows,$target,$parameters,$type);
            }

         } else {
            echo "<div align='center'><b>".$LANG['plugin_manufacturersimports']['config'][10]."</b></div>";
         }
      }
   }

   function printPager($start,$numrows,$target,$parameters,$item_type_output=0,$item_type_output_param=0) {
      global $CFG_GLPI, $LANG;

      $list_limit=$_SESSION['glpilist_limit'];
      // Forward is the next step forward
      $forward = $start+$list_limit;

      // This is the end, my friend
      $end = $numrows-$list_limit;

      // Human readable count starts here
      $current_start=$start+1;

      // And the human is viewing from start to end
      $current_end = $current_start+$list_limit-1;
      if ($current_end>$numrows) {
         $current_end = $numrows;
      }

      // Backward browsing
      if ($current_start-$list_limit<=0) {
         $back=0;
      } else {
         $back=$start-$list_limit;
      }

      // Print it

      echo "<table class='tab_cadre_pager'>\n";
      echo "<tr>\n";

      // Back and fast backward button
      if (!$start==0) {
         echo "<th class='left'>";
         echo "<a href=\"$target?$parameters&amp;start=0\">";
         echo "<img src=\"".$CFG_GLPI["root_doc"]."/pics/first.png\" alt='".$LANG['buttons'][33]."' title='".$LANG['buttons'][33]."'>";


         echo "</a></th>\n";
         echo "<th class='left'>";
         echo "<a href=\"$target?$parameters&amp;start=$back\">";
         echo "<img src=\"".$CFG_GLPI["root_doc"]."/pics/left.png\" alt='".$LANG['buttons'][12]."' title='".$LANG['buttons'][12]."'>";
         echo "</a></th>\n";
      }

      // Print the "where am I?"
      echo "<td width='50%'  class='tab_bg_2'>";
      printPagerForm("$target?$parameters&amp;start=$start");
      echo "</td>\n";

      echo "<td  width='50%'  class='tab_bg_2 b'>";

      echo $LANG['pager'][2]."&nbsp;".$current_start."&nbsp;".$LANG['pager'][1]."&nbsp;".$current_end."&nbsp;".$LANG['pager'][3]."&nbsp;".$numrows."&nbsp;";
      echo "</td>\n";

      // Forward and fast forward button
      if ($forward<$numrows) {
         echo "<th class='right'>";
         echo "<a href=\"$target?$parameters&amp;start=$forward\">";
         echo "<img src=\"".$CFG_GLPI["root_doc"]."/pics/right.png\" alt='".$LANG['buttons'][11]."' title='".$LANG['buttons'][11]."'>";
         echo "</a></th>\n";
         echo "<th class='right'>";
         echo "<a href=\"$target?$parameters&amp;start=$end\">";
         echo "<img src=\"".$CFG_GLPI["root_doc"]."/pics/last.png\" alt='".$LANG['buttons'][32]."' title='".$LANG['buttons'][32]."'>";
         echo "</a></th>\n";
      }

      // End pager
      echo "</tr>\n";
      echo "</table><br>\n";

   }

   function dropdownMassiveAction($ID,$type,$manufacturer,$start,$imported) {
      global $LANG,$CFG_GLPI;

      echo "<select name=\"massiveaction\" id='massiveaction'>";
      echo "<option value=\"-1\" selected>".DROPDOWN_EMPTY_VALUE."</option>";
      //not imported
      if ($imported==1) {
         echo "<option value=\"import\">".$LANG['plugin_manufacturersimports']['import'][9]."</option>";
      }
      echo "<option value=\"reinit_once\">".$LANG['plugin_manufacturersimports']['import'][20]."</option>";

      echo "</select>";

      $params=array('action'=>'__VALUE__',
        'manufacturers_id'=>$manufacturer,
        'itemtype'=>$type,
        'start'=>$start,
        'imported'=>$imported,
        'id'=>$ID,
        );

      ajaxUpdateItemOnSelectEvent("massiveaction","show_massiveaction",$CFG_GLPI["root_doc"]."/plugins/manufacturersimports/ajax/dropdownMassiveAction.php",$params);

      echo "<span id='show_massiveaction'>&nbsp;</span>\n";

   }
}

?>