<?php
/*
 * @version $Id: HEADER 2011-03-12 18:01:26 tsmr $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2010 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
// ----------------------------------------------------------------------
// Original Author of file: CAILLAUD Xavier
// Purpose of file: plugin manufacturersimports v1.4.0 - GLPI 0.80
// ----------------------------------------------------------------------
 */

include_once ("inc/profile.class.php");

// Init the hooks of the plugins -Needed
function plugin_init_manufacturersimports() {
	global $PLUGIN_HOOKS,$CFG_GLPI,$LANG;

	$PLUGIN_HOOKS['change_profile']['manufacturersimports'] = array('PluginManufacturersimportsProfile','changeProfile');
	
	//Clean Plugin on Profile delete
   $PLUGIN_HOOKS['pre_item_purge']['manufacturersimports'] = array('Profile'=>array('PluginManufacturersimportsProfile', 'purgeProfiles'));
   
	if (getLoginUserID()) {

		if (plugin_manufacturersimports_haveRight("manufacturersimports","r")) {
         $PLUGIN_HOOKS['menu_entry']['manufacturersimports'] = 'front/import.php';
         $PLUGIN_HOOKS['submenu_entry']['manufacturersimports']['config'] = 'front/config.form.php';
         $PLUGIN_HOOKS['add_css']['manufacturersimports']="manufacturersimports.css";
         $PLUGIN_HOOKS['use_massive_action']['manufacturersimports']=1;

		}
		
		if (plugin_manufacturersimports_haveRight("manufacturersimports","r") || haveRight("config","w")) {
         $PLUGIN_HOOKS['config_page']['manufacturersimports'] = 'front/config.form.php';
         $PLUGIN_HOOKS['headings']['manufacturersimports'] = 'plugin_get_headings_manufacturersimports';
         $PLUGIN_HOOKS['headings_action']['manufacturersimports'] = 'plugin_headings_actions_manufacturersimports';
      }
	}
}

// Get the name and the version of the plugin - Needed
function plugin_version_manufacturersimports() {
	global $LANG;

	return array (
		'name' => $LANG['plugin_manufacturersimports']['title'][1],
		'oldname' => 'suppliertag',
		'version' => '1.4.1',
		'oldname' => 'suppliertag',
		'author'=>'Xavier Caillaud',
		'homepage'=>'https://forge.indepnet.net/projects/show/manufacturersimports',
		'minGlpiVersion' => '0.80',// For compatibility / no install in version < 0.80
	);

}

// Optional : check prerequisites before install : may print errors or add to message after redirect
function plugin_manufacturersimports_check_prerequisites() {
	if (GLPI_VERSION>=0.80) {
		return true;
	} else {
		echo "GLPI version not compatible need 0.80";
	}
}

// Uninstall process for plugin : need to return true if succeeded : may display messages or add to message after redirect
function plugin_manufacturersimports_check_config() {
	return true;
}

function plugin_manufacturersimports_haveRight($module,$right) {
	$matches=array(
			""  => array("","r","w"), // ne doit pas arriver normalement
			"r" => array("r","w"),
			"w" => array("w"),
			"1" => array("1"),
			"0" => array("0","1"), // ne doit pas arriver non plus
		      );
	if (isset($_SESSION["glpi_plugin_manufacturersimports_profile"][$module])&&in_array($_SESSION["glpi_plugin_manufacturersimports_profile"][$module],$matches[$right]))
		return true;
	else return false;
}

?>